searchData={"items":[{"type":"module","title":"Crawler","doc":"A high performance web crawler in Elixir.","ref":"Crawler.html"},{"type":"function","title":"Crawler.crawl/2","doc":"Enqueues a crawl, via `Crawler.QueueHandler.enqueue/1`.\n\nThis is the default crawl behaviour as the queue determines when an actual\ncrawl should happen based on the available workers and the rate limit. The\nqueue kicks off `Crawler.Dispatcher.Worker` which in turn calls\n`Crawler.crawl_now/1`.","ref":"Crawler.html#crawl/2"},{"type":"function","title":"Crawler.crawl_now/1","doc":"Crawls immediately, this is used by `Crawler.Dispatcher.Worker.start_link/1`.\n\nFor general purpose use cases, always use `Crawler.crawl/2` instead.","ref":"Crawler.html#crawl_now/1"},{"type":"function","title":"Crawler.pause/1","doc":"Pauses the crawler.","ref":"Crawler.html#pause/1"},{"type":"function","title":"Crawler.resume/1","doc":"Resumes the crawler after it was paused.","ref":"Crawler.html#resume/1"},{"type":"function","title":"Crawler.running?/1","doc":"Checks whether the crawler is still crawling.","ref":"Crawler.html#running?/1"},{"type":"function","title":"Crawler.start/2","doc":"Crawler is an application that gets started automatically with:\n\n- a `Crawler.Store` that initiates a `Registry` for keeping internal data","ref":"Crawler.html#start/2"},{"type":"function","title":"Crawler.stop/1","doc":"Stops the crawler.","ref":"Crawler.html#stop/1"},{"type":"module","title":"Crawler.Dispatcher","doc":"Dispatches requests to a queue for crawling.","ref":"Crawler.Dispatcher.html"},{"type":"function","title":"Crawler.Dispatcher.dispatch/2","doc":"Takes the `request` argument which is a tuple containing either:\n\n- `{_, link, _, url}` when it's a link that got transformed into a URL\n- `{_, url}` when it's a URL already\n\nAnd issues `Crawler.crawl/2` to initiate the crawl.","ref":"Crawler.Dispatcher.html#dispatch/2"},{"type":"module","title":"Crawler.Dispatcher.Worker","doc":"A worker that performs the crawling.","ref":"Crawler.Dispatcher.Worker.html"},{"type":"function","title":"Crawler.Dispatcher.Worker.start_link/1","doc":"Kicks off `Crawler.crawl_now/1`.","ref":"Crawler.Dispatcher.Worker.html#start_link/1"},{"type":"module","title":"Crawler.Example.GoogleSearch","doc":"This example performs a Google search, then scrapes the results to find Github\nprojects and output their name and description.\n\nExample output:\n\n    Agent.get(Data, & &1) #=> %{\n      \"crawler\" => %{\n        desc: \"A high performance web crawler / scraper in Elixir.\",\n        url: \"https://github.com/fredwu/crawler\"\n      },\n      \"crawly\" => %{\n        desc: \"Crawly, a high-level web crawling & scraping framework for Elixir.\",\n        url: \"https://github.com/elixir-crawly/crawly\"\n      },\n      \"elixir_scraper\" => %{\n        desc: \"Elixir/Hound web scraper example\",\n        url: \"https://github.com/jaydorsey/elixir_scraper\"\n      },\n      \"mechanize\" => %{\n        desc: \"Build web scrapers and automate interaction with websites in Elixir with ease!\",\n        url: \"https://github.com/gushonorato/mechanize\"\n      }\n    }","ref":"Crawler.Example.GoogleSearch.html"},{"type":"function","title":"Crawler.Example.GoogleSearch.run/0","doc":"","ref":"Crawler.Example.GoogleSearch.html#run/0"},{"type":"module","title":"Crawler.Example.GoogleSearch.Scraper","doc":"We only scrape Github pages, specifically looking for a project's name and description.","ref":"Crawler.Example.GoogleSearch.Scraper.html"},{"type":"function","title":"Crawler.Example.GoogleSearch.Scraper.scrape/1","doc":"","ref":"Crawler.Example.GoogleSearch.Scraper.html#scrape/1"},{"type":"module","title":"Crawler.Example.GoogleSearch.UrlFilter","doc":"We start with Google, then only crawls Github.","ref":"Crawler.Example.GoogleSearch.UrlFilter.html"},{"type":"function","title":"Crawler.Example.GoogleSearch.UrlFilter.filter/2","doc":"","ref":"Crawler.Example.GoogleSearch.UrlFilter.html#filter/2"},{"type":"module","title":"Crawler.Fetcher","doc":"Fetches pages and perform tasks on them.","ref":"Crawler.Fetcher.html"},{"type":"function","title":"Crawler.Fetcher.fetch/1","doc":"Fetches a URL by:\n\n- verifying whether the URL needs fetching through `Crawler.Fetcher.Policer.police/1`\n- recording data for internal use through `Crawler.Fetcher.Recorder.record/1`\n- fetching the URL\n- performing retries upon failed fetches through `Crawler.Fetcher.Retrier.perform/2`","ref":"Crawler.Fetcher.html#fetch/1"},{"type":"module","title":"Crawler.Fetcher.HeaderPreparer","doc":"Captures and prepares HTTP response headers.","ref":"Crawler.Fetcher.HeaderPreparer.html"},{"type":"function","title":"Crawler.Fetcher.HeaderPreparer.prepare/2","doc":"Captures and prepares HTTP response headers.","ref":"Crawler.Fetcher.HeaderPreparer.html#prepare/2"},{"type":"function","title":"Examples - Crawler.Fetcher.HeaderPreparer.prepare/2","doc":"iex> HeaderPreparer.prepare(\n    iex>   [{\"Content-Type\", \"text/html\"}],\n    iex>   %{}\n    iex> )\n    %{headers: [{\"Content-Type\", \"text/html\"}], content_type: \"text/html\"}\n\n    iex> HeaderPreparer.prepare(\n    iex>   [{\"Content-Type\", \"text/css\"}],\n    iex>   %{}\n    iex> )\n    %{headers: [{\"Content-Type\", \"text/css\"}], content_type: \"text/css\"}\n\n    iex> HeaderPreparer.prepare(\n    iex>   [{\"Content-Type\", \"image/png; blah\"}],\n    iex>   %{}\n    iex> )\n    %{headers: [{\"Content-Type\", \"image/png; blah\"}], content_type: \"image/png\"}","ref":"Crawler.Fetcher.HeaderPreparer.html#prepare/2-examples"},{"type":"module","title":"Crawler.Fetcher.Modifier","doc":"Modifies request options and headers before dispatch.","ref":"Crawler.Fetcher.Modifier.html"},{"type":"function","title":"Crawler.Fetcher.Modifier.headers/1","doc":"Allows modifying headers prior to making a crawl request.","ref":"Crawler.Fetcher.Modifier.html#headers/1"},{"type":"function","title":"Example implementation - Crawler.Fetcher.Modifier.headers/1","doc":"def headers(opts) do\n      if opts[:url] == \"http://modifier\" do\n        [{\"Referer\", \"http://fetcher\"}]\n      end\n      []\n    end","ref":"Crawler.Fetcher.Modifier.html#headers/1-example-implementation"},{"type":"function","title":"Crawler.Fetcher.Modifier.opts/1","doc":"Allows passing opts to httpPoison prior to making the crawl request","ref":"Crawler.Fetcher.Modifier.html#opts/1"},{"type":"function","title":"Example implementation - Crawler.Fetcher.Modifier.opts/1","doc":"def opts(opts) do\n      if opts[:url] == \"http://modifier\" do\n        # add a new pool to hackney\n        [hackney: [pool: :modifier]]\n      end\n      []\n    end","ref":"Crawler.Fetcher.Modifier.html#opts/1-example-implementation"},{"type":"behaviour","title":"Crawler.Fetcher.Modifier.Spec","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html"},{"type":"callback","title":"Crawler.Fetcher.Modifier.Spec.headers/1","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#c:headers/1"},{"type":"callback","title":"Crawler.Fetcher.Modifier.Spec.opts/1","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#c:opts/1"},{"type":"type","title":"Crawler.Fetcher.Modifier.Spec.header/0","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:header/0"},{"type":"type","title":"Crawler.Fetcher.Modifier.Spec.opts/0","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:opts/0"},{"type":"type","title":"Crawler.Fetcher.Modifier.Spec.url/0","doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:url/0"},{"type":"module","title":"Crawler.Fetcher.Policer","doc":"Checks a series of conditions to determine whether it is okay to continue.","ref":"Crawler.Fetcher.Policer.html"},{"type":"function","title":"Crawler.Fetcher.Policer.police/1","doc":"Checks a series of conditions to determine whether it is okay to continue,\ni.e. to allow `Crawler.Fetcher.fetch/1` to begin its tasks.","ref":"Crawler.Fetcher.Policer.html#police/1"},{"type":"module","title":"Crawler.Fetcher.Recorder","doc":"Records information about each crawl for internal use.","ref":"Crawler.Fetcher.Recorder.html"},{"type":"function","title":"Crawler.Fetcher.Recorder.maybe_store_page/2","doc":"Stores page data in `Crawler.Store.DB` for internal or external consumption, if enabled.","ref":"Crawler.Fetcher.Recorder.html#maybe_store_page/2"},{"type":"function","title":"Examples - Crawler.Fetcher.Recorder.maybe_store_page/2","doc":"iex> Recorder.maybe_store_page(\"body\", %{store: nil})\n    {:ok, nil}\n\n    iex> Recorder.record(url: \"url\", depth: 2)\n    iex> Recorder.maybe_store_page(\"body\", %{store: Store, url: \"url\"})\n    {:ok, {%Page{url: \"url\", body: \"body\", opts: %{store: Store, url: \"url\"}}, %Page{url: \"url\", body: nil}}}","ref":"Crawler.Fetcher.Recorder.html#maybe_store_page/2-examples"},{"type":"function","title":"Crawler.Fetcher.Recorder.record/1","doc":"Records information about each crawl for internal use.","ref":"Crawler.Fetcher.Recorder.html#record/1"},{"type":"function","title":"Examples - Crawler.Fetcher.Recorder.record/1","doc":"iex> Recorder.record(url: \"url1\", depth: 2)\n    {:ok, %{depth: 3, url: \"url1\"}}\n\n    iex> Recorder.record(url: \"url2\", depth: 2)\n    iex> Store.find(\"url2\")\n    %Page{url: \"url2\"}","ref":"Crawler.Fetcher.Recorder.html#record/1-examples"},{"type":"module","title":"Crawler.Fetcher.Requester","doc":"Makes HTTP requests.","ref":"Crawler.Fetcher.Requester.html"},{"type":"function","title":"Crawler.Fetcher.Requester.make/1","doc":"Makes HTTP requests via `Crawler.HTTP`.","ref":"Crawler.Fetcher.Requester.html#make/1"},{"type":"function","title":"Examples - Crawler.Fetcher.Requester.make/1","doc":"iex> Requester.make(url: \"fake.url\", modifier: Crawler.Fetcher.Modifier)\n    {:error, %HTTPoison.Error{id: nil, reason: :nxdomain}}","ref":"Crawler.Fetcher.Requester.html#make/1-examples"},{"type":"module","title":"Crawler.Fetcher.Retrier","doc":"Handles retries for failed crawls.","ref":"Crawler.Fetcher.Retrier.html"},{"type":"function","title":"Crawler.Fetcher.Retrier.perform/2","doc":"More information: [https://github.com/safwank/ElixirRetry](https://github.com/safwank/ElixirRetry)","ref":"Crawler.Fetcher.Retrier.html#perform/2"},{"type":"behaviour","title":"Crawler.Fetcher.Retrier.Spec","doc":"Spec for defining a fetch retrier.","ref":"Crawler.Fetcher.Retrier.Spec.html"},{"type":"callback","title":"Crawler.Fetcher.Retrier.Spec.perform/2","doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#c:perform/2"},{"type":"type","title":"Crawler.Fetcher.Retrier.Spec.fetch_url/0","doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#t:fetch_url/0"},{"type":"type","title":"Crawler.Fetcher.Retrier.Spec.opts/0","doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#t:opts/0"},{"type":"module","title":"Crawler.Fetcher.UrlFilter","doc":"A placeholder module that lets all URLs pass through.","ref":"Crawler.Fetcher.UrlFilter.html"},{"type":"function","title":"Crawler.Fetcher.UrlFilter.filter/2","doc":"Whether to pass through a given URL.\n\n- `true` for letting the url through\n- `false` for rejecting the url","ref":"Crawler.Fetcher.UrlFilter.html#filter/2"},{"type":"behaviour","title":"Crawler.Fetcher.UrlFilter.Spec","doc":"Spec for defining an url filter.","ref":"Crawler.Fetcher.UrlFilter.Spec.html"},{"type":"callback","title":"Crawler.Fetcher.UrlFilter.Spec.filter/2","doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#c:filter/2"},{"type":"type","title":"Crawler.Fetcher.UrlFilter.Spec.opts/0","doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#t:opts/0"},{"type":"type","title":"Crawler.Fetcher.UrlFilter.Spec.url/0","doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#t:url/0"},{"type":"module","title":"Crawler.HTTP","doc":"Custom HTTPoison base module for potential customisation.","ref":"Crawler.HTTP.html"},{"type":"function","title":"Crawler.HTTP.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#delete/3"},{"type":"function","title":"Crawler.HTTP.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#delete!/3"},{"type":"function","title":"Crawler.HTTP.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#get/3"},{"type":"function","title":"Crawler.HTTP.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#get!/3"},{"type":"function","title":"Crawler.HTTP.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#head/3"},{"type":"function","title":"Crawler.HTTP.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#head!/3"},{"type":"function","title":"Crawler.HTTP.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#options/3"},{"type":"function","title":"Crawler.HTTP.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#options!/3"},{"type":"function","title":"Crawler.HTTP.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#patch/4"},{"type":"function","title":"Crawler.HTTP.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#patch!/4"},{"type":"function","title":"Crawler.HTTP.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#post/4"},{"type":"function","title":"Crawler.HTTP.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#post!/4"},{"type":"function","title":"Crawler.HTTP.process_headers/1","doc":"","ref":"Crawler.HTTP.html#process_headers/1"},{"type":"function","title":"Crawler.HTTP.process_request_body/1","doc":"","ref":"Crawler.HTTP.html#process_request_body/1"},{"type":"function","title":"Crawler.HTTP.process_request_headers/1","doc":"","ref":"Crawler.HTTP.html#process_request_headers/1"},{"type":"function","title":"Crawler.HTTP.process_request_options/1","doc":"","ref":"Crawler.HTTP.html#process_request_options/1"},{"type":"function","title":"Crawler.HTTP.process_request_params/1","doc":"","ref":"Crawler.HTTP.html#process_request_params/1"},{"type":"function","title":"Crawler.HTTP.process_request_url/1","doc":"","ref":"Crawler.HTTP.html#process_request_url/1"},{"type":"function","title":"Crawler.HTTP.process_response/1","doc":"","ref":"Crawler.HTTP.html#process_response/1"},{"type":"function","title":"Crawler.HTTP.process_response_body/1","doc":"","ref":"Crawler.HTTP.html#process_response_body/1"},{"type":"function","title":"Crawler.HTTP.process_response_chunk/1","doc":"","ref":"Crawler.HTTP.html#process_response_chunk/1"},{"type":"function","title":"Crawler.HTTP.process_response_headers/1","doc":"","ref":"Crawler.HTTP.html#process_response_headers/1"},{"type":"function","title":"Crawler.HTTP.process_response_status_code/1","doc":"","ref":"Crawler.HTTP.html#process_response_status_code/1"},{"type":"function","title":"Crawler.HTTP.process_status_code/1","doc":"","ref":"Crawler.HTTP.html#process_status_code/1"},{"type":"function","title":"Crawler.HTTP.process_url/1","doc":"","ref":"Crawler.HTTP.html#process_url/1"},{"type":"function","title":"Crawler.HTTP.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Crawler.HTTP.html#put/4"},{"type":"function","title":"Crawler.HTTP.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#put!/4"},{"type":"function","title":"Crawler.HTTP.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Crawler.HTTP.html#request/1"},{"type":"function","title":"Redirect handling - Crawler.HTTP.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Crawler.HTTP.html#request/1-redirect-handling"},{"type":"function","title":"Examples - Crawler.HTTP.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"Crawler.HTTP.html#request/1-examples"},{"type":"function","title":"Crawler.HTTP.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Crawler.HTTP.html#request/5"},{"type":"function","title":"Redirect handling - Crawler.HTTP.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Crawler.HTTP.html#request/5-redirect-handling"},{"type":"function","title":"Examples - Crawler.HTTP.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"Crawler.HTTP.html#request/5-examples"},{"type":"function","title":"Crawler.HTTP.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Crawler.HTTP.html#request!/5"},{"type":"function","title":"Crawler.HTTP.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"Crawler.HTTP.html#start/0"},{"type":"function","title":"Crawler.HTTP.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"Crawler.HTTP.html#stream_next/1"},{"type":"type","title":"Crawler.HTTP.body/0","doc":"","ref":"Crawler.HTTP.html#t:body/0"},{"type":"type","title":"Crawler.HTTP.headers/0","doc":"","ref":"Crawler.HTTP.html#t:headers/0"},{"type":"type","title":"Crawler.HTTP.method/0","doc":"","ref":"Crawler.HTTP.html#t:method/0"},{"type":"type","title":"Crawler.HTTP.options/0","doc":"","ref":"Crawler.HTTP.html#t:options/0"},{"type":"type","title":"Crawler.HTTP.params/0","doc":"","ref":"Crawler.HTTP.html#t:params/0"},{"type":"type","title":"Crawler.HTTP.request/0","doc":"","ref":"Crawler.HTTP.html#t:request/0"},{"type":"type","title":"Crawler.HTTP.url/0","doc":"","ref":"Crawler.HTTP.html#t:url/0"},{"type":"module","title":"Crawler.Linker","doc":"A set of high level functions for making online and offline URLs and links.","ref":"Crawler.Linker.html"},{"type":"function","title":"Crawler.Linker.link/2","doc":"Given the `current_link`, it works out what the relative link should be for\n`link`.","ref":"Crawler.Linker.html#link/2"},{"type":"function","title":"Examples - Crawler.Linker.link/2","doc":"iex> Linker.link(\n    iex>   \"http://another.domain/page.html\",\n    iex>   \"/dir/page2\"\n    iex> )\n    \"../another.domain/dir/page2\"\n\n    iex> Linker.link(\n    iex>   \"http://another.domain/page\",\n    iex>   \"/dir/page2\"\n    iex> )\n    \"../../another.domain/dir/page2\"\n\n    iex> Linker.link(\n    iex>   \"http://another.domain/parent/page\",\n    iex>   \"dir/page2\"\n    iex> )\n    \"../../../another.domain/parent/dir/page2\"\n\n    iex> Linker.link(\n    iex>   \"http://another.domain/parent/page\",\n    iex>   \"../dir/page2\"\n    iex> )\n    \"../../../another.domain/dir/page2\"","ref":"Crawler.Linker.html#link/2-examples"},{"type":"function","title":"Crawler.Linker.offline_link/2","doc":"Given the `current_link`, it works out what the relative\noffline link should be for `link`.","ref":"Crawler.Linker.html#offline_link/2"},{"type":"function","title":"Examples - Crawler.Linker.offline_link/2","doc":"iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"page1\"\n    iex> )\n    \"../../../hello.world/dir/page1/index.html\"\n\n    iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"page1.html\"\n    iex> )\n    \"../../../hello.world/dir/page1.html\"\n\n    iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"../page1\"\n    iex> )\n    \"../../../hello.world/page1/index.html\"\n\n    iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"../page1.html\"\n    iex> )\n    \"../../../hello.world/page1.html\"\n\n    iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"http://thank.you/page1\"\n    iex> )\n    \"../../../thank.you/page1/index.html\"\n\n    iex> Linker.offline_link(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"http://thank.you/page1.html\"\n    iex> )\n    \"../../../thank.you/page1.html\"","ref":"Crawler.Linker.html#offline_link/2-examples"},{"type":"function","title":"Crawler.Linker.offline_url/2","doc":"Given the `current_link`, it works out what the offline URL should be for\n`link`.","ref":"Crawler.Linker.html#offline_url/2"},{"type":"function","title":"Examples - Crawler.Linker.offline_url/2","doc":"iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"page1\"\n    iex> )\n    \"http://hello.world/dir/page1/index.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"page1.html\"\n    iex> )\n    \"http://hello.world/dir/page1.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"../page1\"\n    iex> )\n    \"http://hello.world/page1/index.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"../page1.html\"\n    iex> )\n    \"http://hello.world/page1.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"http://thank.you/page1\"\n    iex> )\n    \"http://thank.you/page1/index.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"http://thank.you/page1.html\"\n    iex> )\n    \"http://thank.you/page1.html\"\n\n    iex> Linker.offline_url(\n    iex>   \"http://hello.world/dir/page\",\n    iex>   \"http://thank.you/\"\n    iex> )\n    \"http://thank.you/index.html\"","ref":"Crawler.Linker.html#offline_url/2-examples"},{"type":"function","title":"Crawler.Linker.url/2","doc":"Given the `current_link`, it works out what the URL should be for `link`.","ref":"Crawler.Linker.html#url/2"},{"type":"function","title":"Examples - Crawler.Linker.url/2","doc":"iex> Linker.url(\n    iex>   \"http://another.domain:8888/page\",\n    iex>   \"/dir/page2\"\n    iex> )\n    \"http://another.domain:8888/dir/page2\"\n\n    iex> Linker.url(\n    iex>   \"http://another.domain:8888/parent/page\",\n    iex>   \"dir/page2\"\n    iex> )\n    \"http://another.domain:8888/parent/dir/page2\"","ref":"Crawler.Linker.html#url/2-examples"},{"type":"module","title":"Crawler.Linker.PathBuilder","doc":"Builds a path for a link (can be a URL itself or a relative link) based on\nthe input string which is a URL with or without its protocol.","ref":"Crawler.Linker.PathBuilder.html"},{"type":"function","title":"Crawler.Linker.PathBuilder.build_path/3","doc":"Builds a path for a link (can be a URL itself or a relative link) based on\nthe input string which is a URL with or without its protocol.","ref":"Crawler.Linker.PathBuilder.html#build_path/3"},{"type":"function","title":"Examples - Crawler.Linker.PathBuilder.build_path/3","doc":"iex> PathBuilder.build_path(\n    iex>   \"https://cool.beans:7777/dir/page1\",\n    iex>   \"https://hello.world:8888/remote/page2\"\n    iex> )\n    \"hello.world-8888/remote/page2\"\n\n    iex> PathBuilder.build_path(\n    iex>   \"https://cool.beans:7777/dir/page1\",\n    iex>   \"local/page2\"\n    iex> )\n    \"cool.beans-7777/dir/local/page2\"\n\n    iex> PathBuilder.build_path(\n    iex>   \"https://cool.beans:7777/dir/page1\",\n    iex>   \"/local/page2\"\n    iex> )\n    \"cool.beans-7777/local/page2\"\n\n    iex> PathBuilder.build_path(\n    iex>   \"https://cool.beans:7777/parent/dir/page1\",\n    iex>   \"../local/page2\"\n    iex> )\n    \"cool.beans-7777/parent/local/page2\"\n\n    iex> PathBuilder.build_path(\n    iex>   \"https://cool.beans:7777/parent/dir/page1\",\n    iex>   \"../../local/page2\"\n    iex> )\n    \"cool.beans-7777/local/page2\"","ref":"Crawler.Linker.PathBuilder.html#build_path/3-examples"},{"type":"module","title":"Crawler.Linker.PathExpander","doc":"Expands the path by expanding any `.` and `..` characters.\n\nSee [this pull request](https://github.com/elixir-lang/elixir/pull/6486).","ref":"Crawler.Linker.PathExpander.html"},{"type":"function","title":"Crawler.Linker.PathExpander.expand_dot/1","doc":"Expands the path by expanding any `.` and `..` characters.\n\nNote this function only expands any `.` and `..` characters within the given\npath, and it does not take into account the absolute or relative nature of\nthe path itself, for that please use `expand/1` or `expand/2`.","ref":"Crawler.Linker.PathExpander.html#expand_dot/1"},{"type":"function","title":"Examples - Crawler.Linker.PathExpander.expand_dot/1","doc":"#","ref":"Crawler.Linker.PathExpander.html#expand_dot/1-examples"},{"type":"function","title":"Intended use case - Crawler.Linker.PathExpander.expand_dot/1","doc":"iex> PathExpander.expand_dot(\"foo/bar/../baz\")\n    \"foo/baz\"\n\n    iex> PathExpander.expand_dot(\"/foo/bar/../baz\")\n    \"/foo/baz\"\n\n    #","ref":"Crawler.Linker.PathExpander.html#expand_dot/1-intended-use-case"},{"type":"function","title":"Non-intended use cases are ignored - Crawler.Linker.PathExpander.expand_dot/1","doc":"iex> PathExpander.expand_dot(\"foo/bar/./baz\")\n    \"foo/bar/baz\"\n\n    iex> PathExpander.expand_dot(\"../foo/bar\")\n    \"foo/bar\"","ref":"Crawler.Linker.PathExpander.html#expand_dot/1-non-intended-use-cases-are-ignored"},{"type":"module","title":"Crawler.Linker.PathFinder","doc":"Finds different components of a given URL, e.g. its domain name, directory\npath, or full path.\n\nThe `safe` option in some the functions indicates whether the return value\nshould be transformed in order to be safely used as folder and file names.","ref":"Crawler.Linker.PathFinder.html"},{"type":"function","title":"Crawler.Linker.PathFinder.find_base_path/2","doc":"Finds the base path of a given page.","ref":"Crawler.Linker.PathFinder.html#find_base_path/2"},{"type":"function","title":"Examples - Crawler.Linker.PathFinder.find_base_path/2","doc":"iex> PathFinder.find_base_path(\"http://hi.hello\")\n    \"hi.hello\"\n\n    iex> PathFinder.find_base_path(\"https://hi.hello:8888/dir/world\")\n    \"hi.hello-8888/dir\"\n\n    iex> PathFinder.find_base_path(\"https://hi.hello:8888/dir/world\", false)\n    \"hi.hello:8888/dir\"","ref":"Crawler.Linker.PathFinder.html#find_base_path/2-examples"},{"type":"function","title":"Crawler.Linker.PathFinder.find_domain/2","doc":"Finds the domain name with port number (e.g. `example.org:8080`).","ref":"Crawler.Linker.PathFinder.html#find_domain/2"},{"type":"function","title":"Examples - Crawler.Linker.PathFinder.find_domain/2","doc":"iex> PathFinder.find_domain(\"http://hi.hello\")\n    \"hi.hello\"\n\n    iex> PathFinder.find_domain(\"https://hi.hello:8888/world\")\n    \"hi.hello-8888\"\n\n    iex> PathFinder.find_domain(\"https://hi.hello:8888/world\", false)\n    \"hi.hello:8888\"","ref":"Crawler.Linker.PathFinder.html#find_domain/2-examples"},{"type":"function","title":"Crawler.Linker.PathFinder.find_path/2","doc":"Finds the full path of a given page.","ref":"Crawler.Linker.PathFinder.html#find_path/2"},{"type":"function","title":"Examples - Crawler.Linker.PathFinder.find_path/2","doc":"iex> PathFinder.find_path(\"http://hi.hello\")\n    \"hi.hello\"\n\n    iex> PathFinder.find_path(\"https://hi.hello:8888/world\")\n    \"hi.hello-8888/world\"\n\n    iex> PathFinder.find_path(\"https://hi.hello:8888/world\", false)\n    \"hi.hello:8888/world\"","ref":"Crawler.Linker.PathFinder.html#find_path/2-examples"},{"type":"function","title":"Crawler.Linker.PathFinder.find_scheme/1","doc":"Finds the URL scheme (e.g. `https://`).","ref":"Crawler.Linker.PathFinder.html#find_scheme/1"},{"type":"function","title":"Examples - Crawler.Linker.PathFinder.find_scheme/1","doc":"iex> PathFinder.find_scheme(\"http://hi.hello\")\n    \"http://\"\n\n    iex> PathFinder.find_scheme(\"https://hi.hello:8888/\")\n    \"https://\"","ref":"Crawler.Linker.PathFinder.html#find_scheme/1-examples"},{"type":"module","title":"Crawler.Linker.PathOffliner","doc":"Transforms a link to be storable and linkable offline.","ref":"Crawler.Linker.PathOffliner.html"},{"type":"function","title":"Crawler.Linker.PathOffliner.transform/1","doc":"Transforms a given link so that it can be stored and linked to by other pages.\n\nWhen a page does not have a file extension (e.g. html) it is treated as the\nindex page for a directory, therefore `index.html` is appended to the link.","ref":"Crawler.Linker.PathOffliner.html#transform/1"},{"type":"function","title":"Examples - Crawler.Linker.PathOffliner.transform/1","doc":"iex> PathOffliner.transform(\"http://hello.world\")\n    \"http://hello.world/index.html\"\n\n    iex> PathOffliner.transform(\"hello.world\")\n    \"hello.world/index.html\"\n\n    iex> PathOffliner.transform(\"hello.world/\")\n    \"hello.world/index.html\"\n\n    iex> PathOffliner.transform(\"hello/world\")\n    \"hello/world/index.html\"\n\n    iex> PathOffliner.transform(\"hello/world.html\")\n    \"hello/world.html\"","ref":"Crawler.Linker.PathOffliner.html#transform/1-examples"},{"type":"module","title":"Crawler.Linker.PathPrefixer","doc":"Returns prefixes (`../`s) according to the given URL's structure.","ref":"Crawler.Linker.PathPrefixer.html"},{"type":"function","title":"Crawler.Linker.PathPrefixer.prefix/1","doc":"Returns prefixes (`../`s) according to the given URL's structure.","ref":"Crawler.Linker.PathPrefixer.html#prefix/1"},{"type":"function","title":"Examples - Crawler.Linker.PathPrefixer.prefix/1","doc":"iex> PathPrefixer.prefix(\"https://hello.world/\")\n    \"../\"\n\n    iex> PathPrefixer.prefix(\"https://hello.world/page.html\")\n    \"../\"\n\n    iex> PathPrefixer.prefix(\"https://hello.world/page\")\n    \"../../\"\n\n    iex> PathPrefixer.prefix(\"https://hello.world/dir/page.html\")\n    \"../../\"\n\n    iex> PathPrefixer.prefix(\"https://hello.world/dir/page\")\n    \"../../../\"","ref":"Crawler.Linker.PathPrefixer.html#prefix/1-examples"},{"type":"module","title":"Crawler.Options","doc":"Options for the crawler.","ref":"Crawler.Options.html"},{"type":"function","title":"Crawler.Options.assign_defaults/1","doc":"Assigns default option values.","ref":"Crawler.Options.html#assign_defaults/1"},{"type":"function","title":"Examples - Crawler.Options.assign_defaults/1","doc":"iex> Options.assign_defaults(%{}) |> Map.has_key?(:depth)\n    true\n\n    iex> Options.assign_defaults(%{}) |> Map.get(:max_depths)\n    3\n\n    iex> Options.assign_defaults(%{max_depths: 4}) |> Map.get(:max_depths)\n    4","ref":"Crawler.Options.html#assign_defaults/1-examples"},{"type":"function","title":"Crawler.Options.assign_url/2","doc":"Takes the `url` argument and puts it in the `opts`.\n\nThe `opts` map gets passed around internally and eventually gets stored in\nthe registry.","ref":"Crawler.Options.html#assign_url/2"},{"type":"function","title":"Examples - Crawler.Options.assign_url/2","doc":"iex> Options.assign_url(%{}, \"http://options/\")\n    %{url: \"http://options/\"}\n\n    iex> Options.assign_url(%{url: \"http://example.com/\"}, \"http://options/\")\n    %{url: \"http://options/\"}","ref":"Crawler.Options.html#assign_url/2-examples"},{"type":"module","title":"Crawler.Parser","doc":"Parses pages and calls a link handler to handle the detected links.","ref":"Crawler.Parser.html"},{"type":"function","title":"Crawler.Parser.parse/1","doc":"Parses the links and returns the page.\n\nThere are two hooks:\n\n- `link_handler` is useful when a custom parser calls this default parser and\nutilises a different link handler for processing links.\n- `scraper` is useful for scraping content immediately as the parser parses\nthe page, alternatively you can simply access the crawled data\nasynchronously, refer to the [README](https://github.com/fredwu/crawler#usage)","ref":"Crawler.Parser.html#parse/1"},{"type":"function","title":"Examples - Crawler.Parser.parse/1","doc":"iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \"Body\",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\"}\n    iex> })\n    iex> page.body\n    \"Body\"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \" Link \",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\"}\n    iex> })\n    iex> page.body\n    \" Link \"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \" Link \",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\"}\n    iex> })\n    iex> page.body\n    \" Link \"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \" Link \",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\"}\n    iex> })\n    iex> page.body\n    \" Link \"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \" Link \",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\", referrer_url: \"http://hello\"}\n    iex> })\n    iex> page.body\n    \" Link \"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: \" Link \",\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"a\", content_type: \"text/html\", referrer_url: \"http://hello\"}\n    iex> })\n    iex> page.body\n    \" Link \"\n\n    iex> {:ok, page} = Parser.parse(%Page{\n    iex>   body: image_file(),\n    iex>   opts: %{scraper: Crawler.Scraper, html_tag: \"img\", content_type: \"image/png\"}\n    iex> })\n    iex> page.body\n    \"#{image_file()}\"","ref":"Crawler.Parser.html#parse/1-examples"},{"type":"function","title":"Crawler.Parser.parse_links/3","doc":"","ref":"Crawler.Parser.html#parse_links/3"},{"type":"module","title":"Crawler.Parser.CssParser","doc":"Parses CSS files.","ref":"Crawler.Parser.CssParser.html"},{"type":"function","title":"Crawler.Parser.CssParser.parse/1","doc":"Parses CSS files.","ref":"Crawler.Parser.CssParser.html#parse/1"},{"type":"function","title":"Examples - Crawler.Parser.CssParser.parse/1","doc":"iex> CssParser.parse(\n    iex>   \"img { url(http://hello.world) }\"\n    iex> )\n    [{\"link\", [{\"href\", \"http://hello.world\"}], []}]\n\n    iex> CssParser.parse(\n    iex>   \"@font-face { src: url('icons.ttf') format('truetype'); }\"\n    iex> )\n    [{\"link\", [{\"href\", \"icons.ttf\"}], []}]\n\n    iex> CssParser.parse(\n    iex>   \"@font-face { src: url('data:application/blah'); }\"\n    iex> )\n    []","ref":"Crawler.Parser.CssParser.html#parse/1-examples"},{"type":"module","title":"Crawler.Parser.Guarder","doc":"Detects whether a page is parsable.","ref":"Crawler.Parser.Guarder.html"},{"type":"function","title":"Crawler.Parser.Guarder.pass?/1","doc":"Detects whether a page is parsable.","ref":"Crawler.Parser.Guarder.html#pass?/1"},{"type":"function","title":"Examples - Crawler.Parser.Guarder.pass?/1","doc":"iex> Guarder.pass?(\n    iex>   %{html_tag: \"link\", content_type: \"text/css\"}\n    iex> )\n    true\n\n    iex> Guarder.pass?(\n    iex>   %{html_tag: \"img\", content_type: \"text/css\"}\n    iex> )\n    false\n\n    iex> Guarder.pass?(\n    iex>   %{html_tag: \"link\", content_type: \"text/css\"}\n    iex> )\n    true\n\n    iex> Guarder.pass?(\n    iex>   %{html_tag: \"link\", content_type: \"image/png\"}\n    iex> )\n    false","ref":"Crawler.Parser.Guarder.html#pass?/1-examples"},{"type":"module","title":"Crawler.Parser.HtmlParser","doc":"Parses HTML files.","ref":"Crawler.Parser.HtmlParser.html"},{"type":"function","title":"Crawler.Parser.HtmlParser.parse/2","doc":"Parses HTML files.","ref":"Crawler.Parser.HtmlParser.html#parse/2"},{"type":"function","title":"Examples - Crawler.Parser.HtmlParser.parse/2","doc":"iex> HtmlParser.parse(\n    iex>   \" Link \",\n    iex>   %{}\n    iex> )\n    [{\"a\", [{\"href\", \"http://hello.world\"}], [\"Link\"]}]\n\n    iex> HtmlParser.parse(\n    iex>   \" js \",\n    iex>   %{assets: [\"js\"]}\n    iex> )\n    []","ref":"Crawler.Parser.HtmlParser.html#parse/2-examples"},{"type":"module","title":"Crawler.Parser.LinkParser","doc":"Parses links and transforms them if necessary.","ref":"Crawler.Parser.LinkParser.html"},{"type":"function","title":"Crawler.Parser.LinkParser.parse/3","doc":"Parses links and transforms them if necessary.","ref":"Crawler.Parser.LinkParser.html#parse/3"},{"type":"function","title":"Examples - Crawler.Parser.LinkParser.parse/3","doc":"iex> LinkParser.parse(\n    iex>   {\"a\", [{\"hello\", \"world\"}, {\"href\", \"http://hello.world\"}], []},\n    iex>   %{},\n    iex>   &Kernel.inspect(&1, Enum.into(&2, []))\n    iex> )\n    \"{\\\"href\\\", \\\"http://hello.world\\\"}\"\n\n    iex> LinkParser.parse(\n    iex>   {\"img\", [{\"hello\", \"world\"}, {\"src\", \"http://hello.world\"}], []},\n    iex>   %{},\n    iex>   &Kernel.inspect(&1, Enum.into(&2, []))\n    iex> )\n    \"{\\\"src\\\", \\\"http://hello.world\\\"}\"","ref":"Crawler.Parser.LinkParser.html#parse/3-examples"},{"type":"module","title":"Crawler.Parser.LinkParser.LinkExpander","doc":"Expands a link into a full URL.","ref":"Crawler.Parser.LinkParser.LinkExpander.html"},{"type":"function","title":"Crawler.Parser.LinkParser.LinkExpander.expand/2","doc":"Expands a link into a full URL.","ref":"Crawler.Parser.LinkParser.LinkExpander.html#expand/2"},{"type":"function","title":"Examples - Crawler.Parser.LinkParser.LinkExpander.expand/2","doc":"iex> LinkExpander.expand({\"href\", \"http://hello.world\"}, %{})\n    {\"href\", \"http://hello.world\"}\n\n    iex> LinkExpander.expand({\"href\", \"page\"}, %{referrer_url: \"http://hello.world\"})\n    {\"link\", \"page\", \"href\", \"http://hello.world/page\"}","ref":"Crawler.Parser.LinkParser.LinkExpander.html#expand/2-examples"},{"type":"behaviour","title":"Crawler.Parser.Spec","doc":"Spec for defining a parser.","ref":"Crawler.Parser.Spec.html"},{"type":"callback","title":"Crawler.Parser.Spec.parse/1","doc":"","ref":"Crawler.Parser.Spec.html#c:parse/1"},{"type":"type","title":"Crawler.Parser.Spec.body/0","doc":"","ref":"Crawler.Parser.Spec.html#t:body/0"},{"type":"type","title":"Crawler.Parser.Spec.opts/0","doc":"","ref":"Crawler.Parser.Spec.html#t:opts/0"},{"type":"type","title":"Crawler.Parser.Spec.page/0","doc":"","ref":"Crawler.Parser.Spec.html#t:page/0"},{"type":"type","title":"Crawler.Parser.Spec.url/0","doc":"","ref":"Crawler.Parser.Spec.html#t:url/0"},{"type":"module","title":"Crawler.QueueHandler","doc":"Handles the queueing of crawl requests.","ref":"Crawler.QueueHandler.html"},{"type":"function","title":"Crawler.QueueHandler.enqueue/1","doc":"Enqueues a crawl request.\n\nAlso initialises the queue if it's not already initialised, this is necessary\nso that consumer apps don't have to manually handle the queue initialisation.","ref":"Crawler.QueueHandler.html#enqueue/1"},{"type":"module","title":"Crawler.Scraper","doc":"A placeholder module that demonstrates the scraping interface.","ref":"Crawler.Scraper.html"},{"type":"function","title":"Crawler.Scraper.scrape/1","doc":"","ref":"Crawler.Scraper.html#scrape/1"},{"type":"behaviour","title":"Crawler.Scraper.Spec","doc":"Spec for defining a scraper.","ref":"Crawler.Scraper.Spec.html"},{"type":"callback","title":"Crawler.Scraper.Spec.scrape/1","doc":"","ref":"Crawler.Scraper.Spec.html#c:scrape/1"},{"type":"type","title":"Crawler.Scraper.Spec.body/0","doc":"","ref":"Crawler.Scraper.Spec.html#t:body/0"},{"type":"type","title":"Crawler.Scraper.Spec.opts/0","doc":"","ref":"Crawler.Scraper.Spec.html#t:opts/0"},{"type":"type","title":"Crawler.Scraper.Spec.page/0","doc":"","ref":"Crawler.Scraper.Spec.html#t:page/0"},{"type":"type","title":"Crawler.Scraper.Spec.url/0","doc":"","ref":"Crawler.Scraper.Spec.html#t:url/0"},{"type":"module","title":"Crawler.Snapper","doc":"Stores crawled pages offline.","ref":"Crawler.Snapper.html"},{"type":"function","title":"Crawler.Snapper.snap/2","doc":"In order to store pages offline, it provides the following functionalities:\n\n- replaces all URLs to their equivalent relative paths\n- creates directories when necessary to store the files","ref":"Crawler.Snapper.html#snap/2"},{"type":"function","title":"Examples - Crawler.Snapper.snap/2","doc":"iex> Snapper.snap(\"hello\", %{save_to: tmp(\"snapper\"), url: \"http://hello-world.local\"})\n    iex> File.read(tmp(\"snapper/hello-world.local\", \"index.html\"))\n    {:ok, \"hello\"}\n\n    iex> Snapper.snap(\"hello\", %{save_to: tmp(\"snapper\"), url: \"http://snapper.local/index.html\"})\n    iex> File.read(tmp(\"snapper/snapper.local\", \"index.html\"))\n    {:ok, \"hello\"}\n\n    iex> Snapper.snap(\"hello\", %{save_to: \"nope\", url: \"http://snapper.local/index.html\"})\n    {:error, \"Cannot write to file nope/snapper.local/index.html, reason: enoent\"}\n\n    iex> Snapper.snap(\"hello\", %{save_to: tmp(\"snapper\"), url: \"http://snapper.local/hello\"})\n    iex> File.read(tmp(\"snapper/snapper.local/hello\", \"index.html\"))\n    {:ok, \"hello\"}\n\n    iex> Snapper.snap(\"hello\", %{save_to: tmp(\"snapper\"), url: \"http://snapper.local/hello1/\"})\n    iex> File.read(tmp(\"snapper/snapper.local/hello1\", \"index.html\"))\n    {:ok, \"hello\"}\n\n    iex> Snapper.snap(\n    iex>   \"  \",\n    iex>   %{\n    iex>     save_to: tmp(\"snapper\"),\n    iex>     url: \"http://snapper.local/depth0\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    iex> File.read(tmp(\"snapper/snapper.local/depth0\", \"index.html\"))\n    {:ok, \"  \"}\n\n    iex> Snapper.snap(\n    iex>   \"  \",\n    iex>   %{\n    iex>     save_to: tmp(\"snapper\"),\n    iex>     url: \"http://snapper.local:7777/dir/depth1\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    iex> File.read(tmp(\"snapper/snapper.local-7777/dir/depth1\", \"index.html\"))\n    {:ok, \"  \"}","ref":"Crawler.Snapper.html#snap/2-examples"},{"type":"module","title":"Crawler.Snapper.DirMaker","doc":"Makes a new (nested) folder according to the options provided.","ref":"Crawler.Snapper.DirMaker.html"},{"type":"function","title":"Crawler.Snapper.DirMaker.make_dir/1","doc":"Makes a new (nested) folder according to the options provided.","ref":"Crawler.Snapper.DirMaker.html#make_dir/1"},{"type":"function","title":"Examples - Crawler.Snapper.DirMaker.make_dir/1","doc":"iex> DirMaker.make_dir(\n    iex>   save_to: tmp(\"snapper/dir_creator\"),\n    iex>   url: \"http://hello-world.local\"\n    iex> )\n    iex> |> Path.relative_to_cwd\n    \"test/tmp/snapper/dir_creator/hello-world.local/index.html\"","ref":"Crawler.Snapper.DirMaker.html#make_dir/1-examples"},{"type":"module","title":"Crawler.Snapper.LinkReplacer","doc":"Replaces links found in a page so they work offline.","ref":"Crawler.Snapper.LinkReplacer.html"},{"type":"function","title":"Crawler.Snapper.LinkReplacer.replace_links/2","doc":"Replaces links found in a page so they work offline.","ref":"Crawler.Snapper.LinkReplacer.html#replace_links/2"},{"type":"function","title":"Examples - Crawler.Snapper.LinkReplacer.replace_links/2","doc":"iex> LinkReplacer.replace_links(\n    iex>   \"  \",\n    iex>   %{\n    iex>     url: \"http://main.domain/dir/page\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    {:ok, \"  \"}\n\n    iex> LinkReplacer.replace_links(\n    iex>   \"  \",\n    iex>   %{\n    iex>     url: \"http://main.domain/page\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    {:ok, \"  \"}\n\n    iex> LinkReplacer.replace_links(\n    iex>   \"  \",\n    iex>   %{\n    iex>     url: \"http://main.domain/dir/page\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    {:ok, \"  \"}\n\n    iex> LinkReplacer.replace_links(\n    iex>   \"  \",\n    iex>   %{\n    iex>     url: \"http://main.domain/dir/page\",\n    iex>     referrer_url: \"http://main.domain/dir/page\",\n    iex>     depth: 1,\n    iex>     max_depths: 2,\n    iex>     html_tag: \"a\",\n    iex>     content_type: \"text/html\",\n    iex>   }\n    iex> )\n    {:ok, \"  \"}","ref":"Crawler.Snapper.LinkReplacer.html#replace_links/2-examples"},{"type":"module","title":"Crawler.Store","doc":"An internal data store for information related to each crawl.","ref":"Crawler.Store.html"},{"type":"function","title":"Crawler.Store.add/1","doc":"Adds a URL to the registry.","ref":"Crawler.Store.html#add/1"},{"type":"function","title":"Crawler.Store.add_page_data/3","doc":"Adds the page data for a URL to the registry.","ref":"Crawler.Store.html#add_page_data/3"},{"type":"function","title":"Crawler.Store.all_urls/0","doc":"","ref":"Crawler.Store.html#all_urls/0"},{"type":"function","title":"Crawler.Store.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Crawler.Store.html#child_spec/1"},{"type":"function","title":"Crawler.Store.find/1","doc":"Finds a stored URL and returns its page data.","ref":"Crawler.Store.html#find/1"},{"type":"function","title":"Crawler.Store.find_processed/1","doc":"Finds a stored URL and returns its page data only if it's processed.","ref":"Crawler.Store.html#find_processed/1"},{"type":"function","title":"Crawler.Store.init/1","doc":"Initialises a new `Registry` named `Crawler.Store.DB`.","ref":"Crawler.Store.html#init/1"},{"type":"function","title":"Crawler.Store.ops_count/0","doc":"","ref":"Crawler.Store.html#ops_count/0"},{"type":"function","title":"Crawler.Store.ops_inc/0","doc":"","ref":"Crawler.Store.html#ops_inc/0"},{"type":"function","title":"Crawler.Store.ops_reset/0","doc":"","ref":"Crawler.Store.html#ops_reset/0"},{"type":"function","title":"Crawler.Store.processed/1","doc":"Marks a URL as processed in the registry.","ref":"Crawler.Store.html#processed/1"},{"type":"function","title":"Crawler.Store.start_link/1","doc":"","ref":"Crawler.Store.html#start_link/1"},{"type":"module","title":"Crawler.Store.Counter","doc":"","ref":"Crawler.Store.Counter.html"},{"type":"function","title":"Crawler.Store.Counter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Crawler.Store.Counter.html#child_spec/1"},{"type":"function","title":"Crawler.Store.Counter.inc/0","doc":"","ref":"Crawler.Store.Counter.html#inc/0"},{"type":"function","title":"Crawler.Store.Counter.reset/0","doc":"","ref":"Crawler.Store.Counter.html#reset/0"},{"type":"function","title":"Crawler.Store.Counter.start_link/1","doc":"","ref":"Crawler.Store.Counter.html#start_link/1"},{"type":"function","title":"Crawler.Store.Counter.value/0","doc":"","ref":"Crawler.Store.Counter.html#value/0"},{"type":"module","title":"Crawler.Store.Page","doc":"An internal struct for keeping the url and content of a crawled page.","ref":"Crawler.Store.Page.html"},{"type":"module","title":"Crawler.Worker","doc":"Handles the crawl tasks.","ref":"Crawler.Worker.html"},{"type":"function","title":"Crawler.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Crawler.Worker.html#child_spec/1"},{"type":"function","title":"Crawler.Worker.handle_cast/2","doc":"A crawl workflow that delegates responsibilities to:\n\n- `Crawler.Fetcher.fetch/1`\n- `Crawler.Parser.parse/1` (or a custom parser)","ref":"Crawler.Worker.html#handle_cast/2"},{"type":"function","title":"Crawler.Worker.init/1","doc":"","ref":"Crawler.Worker.html#init/1"},{"type":"function","title":"Crawler.Worker.run/1","doc":"Runs the worker that casts data to itself to kick off the crawl workflow.","ref":"Crawler.Worker.html#run/1"},{"type":"extras","title":"Changelog","doc":"# Crawler Changelog","ref":"changelog.html"},{"type":"extras","title":"master - Changelog","doc":"","ref":"changelog.html#master"},{"type":"extras","title":"v1.4.0 [2023-10-07] - Changelog","doc":"- [Added] Allow multiple instances of Crawler sharing the same queue\n- [Improved] Logger will now log entries as `debug` or `warn`","ref":"changelog.html#v1-4-0-2023-10-07"},{"type":"extras","title":"v1.3.0 [2023-09-30] - Changelog","doc":"- [Added] `:store` option, defaults to `nil` to save memory usage\n- [Added] `:max_pages` option\n- [Added] `Crawler.running?/1` to check whether Crawler is running\n- [Improved] The queue is being supervised now","ref":"changelog.html#v1-3-0-2023-09-30"},{"type":"extras","title":"v1.2.0 [2023-09-29] - Changelog","doc":"- [Added] `Crawler.Store.all_urls/0` to find all scraped URLs\n- [Improved] Memory usage optimisations","ref":"changelog.html#v1-2-0-2023-09-29"},{"type":"extras","title":"v1.1.2 [2021-10-14] - Changelog","doc":"- [Improved] Documentation improvements (thanks @kianmeng)","ref":"changelog.html#v1-1-2-2021-10-14"},{"type":"extras","title":"v1.1.1 [2020-05-15] - Changelog","doc":"- [Improved] Updated `floki` and other dependencies","ref":"changelog.html#v1-1-1-2020-05-15"},{"type":"extras","title":"v1.1.0 [2019-02-25] - Changelog","doc":"- [Added] `:modifier` option\n- [Added] `:encode_uri` option\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v1-1-0-2019-02-25"},{"type":"extras","title":"v1.0.0 [2017-08-31] - Changelog","doc":"- [Added] Pause / resume / stop Crawler\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v1-0-0-2017-08-31"},{"type":"extras","title":"v0.4.0 [2017-08-28] - Changelog","doc":"- [Added] `:scraper` option to allow scraping content\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v0-4-0-2017-08-28"},{"type":"extras","title":"v0.3.1 [2017-08-28] - Changelog","doc":"- [Improved] `Crawler.Store.DB` now stores the `opts` meta data\n- [Improved] Code documentation\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v0-3-1-2017-08-28"},{"type":"extras","title":"v0.3.0 [2017-08-27] - Changelog","doc":"- [Added] `:retrier` option to allow custom fetch retrying logic\n- [Added] `:url_filter` option to allow custom url filtering logic\n- [Improved] Parser is now more stable and skips unparsable files\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v0-3-0-2017-08-27"},{"type":"extras","title":"v0.2.0 [2017-08-21] - Changelog","doc":"- [Added] `:workers` option\n- [Added] `:interval` option\n- [Added] `:timeout` option\n- [Added] `:user_agent` option\n- [Added] `:save_to` option\n- [Added] `:assets` option\n- [Added] `:parser` option to allow custom parsing logic\n- [Improved] Renamed `:max_levels` to `:max_depths`\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v0-2-0-2017-08-21"},{"type":"extras","title":"v0.1.0 [2017-07-30] - Changelog","doc":"- [Added] A semi-functioning prototype\n- [Added] Finished the very basic crawling function\n- [Added] `:max_levels` option","ref":"changelog.html#v0-1-0-2017-07-30"},{"type":"extras","title":"Overview","doc":"# Crawler\n\n[![Build Status](https://github.com/fredwu/crawler/actions/workflows/ci.yml/badge.svg)](https://github.com/fredwu/crawler/actions)\n[![CodeBeat](https://codebeat.co/badges/76916047-5b66-466d-91d3-7131a269899a)](https://codebeat.co/projects/github-com-fredwu-crawler-master)\n[![Coverage](https://img.shields.io/coveralls/fredwu/crawler.svg)](https://coveralls.io/github/fredwu/crawler?branch=master)\n[![Module Version](https://img.shields.io/hexpm/v/crawler.svg)](https://hex.pm/packages/crawler)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/crawler/)\n[![Total Download](https://img.shields.io/hexpm/dt/crawler.svg)](https://hex.pm/packages/crawler)\n[![License](https://img.shields.io/hexpm/l/crawler.svg)](https://github.com/fredwu/crawler/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/fredwu/crawler.svg)](https://github.com/fredwu/crawler/commits/master)\n\nA high performance web crawler / scraper in Elixir, with worker pooling and rate limiting via [OPQ](https://github.com/fredwu/opq).","ref":"readme.html"},{"type":"extras","title":"Features - Overview","doc":"- Crawl assets (javascript, css and images).\n- Save to disk.\n- Hook for scraping content.\n- Restrict crawlable domains, paths or content types.\n- Limit concurrent crawlers.\n- Limit rate of crawling.\n- Set the maximum crawl depth.\n- Set timeouts.\n- Set retries strategy.\n- Set crawler's user agent.\n- Manually pause/resume/stop the crawler.\n\nSee [Hex documentation](https://hexdocs.pm/crawler/).","ref":"readme.html#features"},{"type":"extras","title":"Architecture - Overview","doc":"Below is a very high level architecture diagram demonstrating how Crawler works.\n\n![](architecture.svg)","ref":"readme.html#architecture"},{"type":"extras","title":"Usage - Overview","doc":"```elixir\nCrawler.crawl(\"http://elixir-lang.org\", max_depths: 2)\n```\n\nThere are several ways to access the crawled page data:\n\n1. Use [`Crawler.Store`](https://hexdocs.pm/crawler/Crawler.Store.html)\n2. Tap into the registry([?](https://hexdocs.pm/elixir/Registry.html)) [`Crawler.Store.DB`](lib/crawler/store.ex)\n3. Use your own [scraper](#custom-modules)\n4. If the `:save_to` option is set, pages will be saved to disk in addition to the above mentioned places\n5. Provide your own [custom parser](#custom-modules) and manage how data is stored and accessed yourself","ref":"readme.html#usage"},{"type":"extras","title":"Configurations - Overview","doc":"| Option        | Type    | Default Value               | Description                                                                                                                                                                                            |\n| ------------- | ------- | --------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |\n| `:assets`     | list    | `[]`                        | Whether to fetch any asset files, available options: `\"css\"`, `\"js\"`, `\"images\"`.                                                                                                                      |\n| `:save_to`    | string  | `nil`                       | When provided, the path for saving crawled pages.                                                                                                                                                      |\n| `:workers`    | integer | `10`                        | Maximum number of concurrent workers for crawling.                                                                                                                                                     |\n| `:interval`   | integer | `0`                         | Rate limit control - number of milliseconds before crawling more pages, defaults to `0` which is effectively no rate limit.                                                                            |\n| `:max_depths` | integer | `3`                         | Maximum nested depth of pages to crawl.                                                                                                                                                                |\n| `:max_pages`  | integer | `:infinity`                 | Maximum amount of pages to crawl.                                                                                                                                                                      |\n| `:timeout`    | integer | `5000`                      | Timeout value for fetching a page, in ms. Can also be set to `:infinity`, useful when combined with `Crawler.pause/1`.                                                                                 |\n| `:store`      | module  | `nil`                       | Module for storing the crawled page data and crawling metadata, defaults to `nil`. You can also set it to `Crawler.Store` or your own, see `Crawler.Store.add_page_data/3` for implementation details. |\n| `:user_agent` | string  | `Crawler/x.x.x (...)`       | User-Agent value sent by the fetch requests.                                                                                                                                                           |\n| `:url_filter` | module  | `Crawler.Fetcher.UrlFilter` | Custom URL filter, useful for restricting crawlable domains, paths or content types.                                                                                                                   |\n| `:retrier`    | module  | `Crawler.Fetcher.Retrier`   | Custom fetch retrier, useful for retrying failed crawls.                                                                                                                                               |\n| `:modifier`   | module  | `Crawler.Fetcher.Modifier`  | Custom modifier, useful for adding custom request headers or options.                                                                                                                                  |\n| `:scraper`    | module  | `Crawler.Scraper`           | Custom scraper, useful for scraping content as soon as the parser parses it.                                                                                                                           |\n| `:parser`     | module  | `Crawler.Parser`            | Custom parser, useful for handling parsing differently or to add extra functionalities.                                                                                                                |\n| `:encode_uri` | boolean | `false`                     | When set to `true` apply the `URI.encode` to the URL to be crawled.                                                                                                                                    |\n| `:queue`      | pid     | `nil`                       | You can pass in an `OPQ` pid so that multiple crawlers can share the same queue.                                                                                                                       |","ref":"readme.html#configurations"},{"type":"extras","title":"Custom Modules - Overview","doc":"It is possible to swap in your custom logic as shown in the configurations section. Your custom modules need to conform to their respective behaviours:\n\n#","ref":"readme.html#custom-modules"},{"type":"extras","title":"Retrier - Overview","doc":"See [`Crawler.Fetcher.Retrier`](lib/crawler/fetcher/retrier.ex).\n\nCrawler uses [ElixirRetry](https://github.com/safwank/ElixirRetry)'s exponential backoff strategy by default.\n\n```elixir\ndefmodule CustomRetrier do\n  @behaviour Crawler.Fetcher.Retrier.Spec\nend\n```\n\n#","ref":"readme.html#retrier"},{"type":"extras","title":"URL Filter - Overview","doc":"See [`Crawler.Fetcher.UrlFilter`](lib/crawler/fetcher/url_filter.ex).\n\n```elixir\ndefmodule CustomUrlFilter do\n  @behaviour Crawler.Fetcher.UrlFilter.Spec\nend\n```\n\n#","ref":"readme.html#url-filter"},{"type":"extras","title":"Scraper - Overview","doc":"See [`Crawler.Scraper`](lib/crawler/scraper.ex).\n\n```elixir\ndefmodule CustomScraper do\n  @behaviour Crawler.Scraper.Spec\nend\n```\n\n#","ref":"readme.html#scraper"},{"type":"extras","title":"Parser - Overview","doc":"See [`Crawler.Parser`](lib/crawler/parser.ex).\n\n```elixir\ndefmodule CustomParser do\n  @behaviour Crawler.Parser.Spec\nend\n```\n\n#","ref":"readme.html#parser"},{"type":"extras","title":"Modifier - Overview","doc":"See [`Crawler.Fetcher.Modifier`](lib/crawler/fetcher/modifier.ex).\n\n```elixir\ndefmodule CustomModifier do\n  @behaviour Crawler.Fetcher.Modifier.Spec\nend\n```","ref":"readme.html#modifier"},{"type":"extras","title":"Pause / Resume / Stop Crawler - Overview","doc":"Crawler provides `pause/1`, `resume/1` and `stop/1`, see below.\n\n```elixir\n{:ok, opts} = Crawler.crawl(\"https://elixir-lang.org\")\n\nCrawler.running?(opts) # => true\n\nCrawler.pause(opts)\n\nCrawler.running?(opts) # => false\n\nCrawler.resume(opts)\n\nCrawler.running?(opts) # => true\n\nCrawler.stop(opts)\n\nCrawler.running?(opts) # => false\n```\n\nPlease note that when pausing Crawler, you would need to set a large enough `:timeout` (or even set it to `:infinity`) otherwise parser would timeout due to unprocessed links.","ref":"readme.html#pause-resume-stop-crawler"},{"type":"extras","title":"Multiple Crawlers - Overview","doc":"It is possible to start multiple crawlers sharing the same queue.\n\n```elixir\n{:ok, queue} = OPQ.init(worker: Crawler.Dispatcher.Worker, workers: 2)\n\nCrawler.crawl(\"https://elixir-lang.org\", queue: queue)\nCrawler.crawl(\"https://github.com\", queue: queue)\n```","ref":"readme.html#multiple-crawlers"},{"type":"extras","title":"Find All Scraped URLs - Overview","doc":"```elixir\nCrawler.Store.all_urls() # => [\"https://elixir-lang.org\", \"https://google.com\", ...]\n```","ref":"readme.html#find-all-scraped-urls"},{"type":"extras","title":"Examples - Overview","doc":"#","ref":"readme.html#examples"},{"type":"extras","title":"Google Search + Github - Overview","doc":"This example performs a Google search, then scrapes the results to find Github projects and output their name and description.\n\nSee the [source code](examples/google_search.ex).\n\nYou can run the example by cloning the repo and run the command:\n\n```shell\nmix run -e \"Crawler.Example.GoogleSearch.run()\"\n```","ref":"readme.html#google-search-github"},{"type":"extras","title":"API Reference - Overview","doc":"Please see https://hexdocs.pm/crawler.","ref":"readme.html#api-reference"},{"type":"extras","title":"Changelog - Overview","doc":"Please see [CHANGELOG.md](CHANGELOG.md).","ref":"readme.html#changelog"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2016 Fred Wu\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the [MIT License](http://fredwu.mit-license.org/).","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}